# -*- coding: utf-8 -*-
"""Embargoed Country Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.simpledbobject import *

embargoed_country_form = EmbargoedCountryForm(submit_text='Create Embargoed Country')


class EmbargoedCountryController(SimpleDbObjectController):
    page_title="Embargoed Country"
    myClass = EmbargoedCountry
    url_prefix="embargoed_country"
    form = embargoed_country_form
    
    @expose(template="mirrormanager.templates.boringform")
    @validate(form=embargoed_country_form)
    #@error_handler(SimpleDbObjectController.new)
    def create(self, **kwargs):
        SimpleDbObjectController.create(self, **kwargs)

    @expose(template="mirrormanager.templates.boringdeleteform")
    def delete(self, obj, **kwargs):
        print obj, kwargs
        obj = model.DBSession.query(EmbargoedCountry).filter_by(id = obj).one()
        obj.name = obj.country_code
        confirmed = kwargs.get('confirmed', None)
        confirm_delete_form = ConfirmDeleteForm(submit_text="Yes, really delete it!")
        if confirmed:
            flash("%s has been deleted." % obj.name)
            model.DBSession.delete(obj)
            redirect(url("/adminview"))
        else:
            form = confirm_delete_form
            page_title = "Item Deletion"
            submit_action = url("/embargoed_country/delete/%s?confirmed=1" % (
                    obj.id))
            return dict(form=form, values=obj,
                    action=submit_action, page_title=page_title)    
