# -*- coding: utf-8 -*-
"""Host ACL IP Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.hostlistitem import HostListitemController

host_acl_ip_form = HostAclIPForm(submit_text='Create Host ACL IP')


class HostAclIPController(HostListitemController):
    submit_action_prefix = "/host_acl_ip"
    page_title = "New Host ACL IP"
    form = host_acl_ip_form

    def do_get(self, id):
        v = model.DBSession.query(HostAclIp).filter_by(id = id).one()
        return dict(values=v, host=v.host)

    def do_create(self, host, kwargs):
        print "host acl ip -- create"
        print kwargs
        host = HostAclIp(host=host.id, ip=kwargs['ip'])
        model.DBSession.add(host)

    @expose(template="mirrormanager.templates.boringhostform")
    def delete(self, id, **kwargs):
        hc = model.DBSession.query(HostAclIp).filter_by(id = id).one()
        host = hc.host
        model.DBSession.delete(hc)
        flash("ACL IP deleted")
        redirect(url("/host/%s" % host))
