# -*- coding: utf-8 -*-
"""Arch Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *

arch_form = ArchForm(submit_text='Create Arch')

class SimpleDbObjectController(BaseController):
    allow_only = predicates.not_anonymous()
    page_title = "My Title"
    form = None
    myClass = None
    url_prefix=None

    def get(self, id):
        print "simpleobject --get"
        print id
        v = self.myClass.get(id)
        return dict(values=v)
    
    @expose(template="mirrormanager.templates.boringform")
    def new(self, **kwargs):
            
        submit_action = url("/%s/create" % self.url_prefix)
        return dict(form=self.form, values=None, action=submit_action,
                page_title=self.page_title)

    def create(self, **kwargs):
        print self.myClass()
        print kwargs
        try:
            obj = self.myClass(**kwargs)
            model.DBSession.add(obj)
        except Exception, er: # probably sqlite IntegrityError but we can't catch that for some reason... 
            print er
            flash("Error: Object already exists")
            raise redirect(url("/%s/new" % self.url_prefix))
        flash("Success: Object created.")
        redirect(url("/adminview"))

    @expose(template="mirrormanager.templates.boringform")
    def read(self, obj):
        submit_action = url("/%s/update/%s" % (self.url_prefix, obj.id))
        return dict(form=self.form, values=obj, action=submit_action,
            page_title=self.page_title)
        
    def update(self, obj, **kwargs):
        print "simpledbobject -- update"
        print obj, kwargs, str(self.myClass())
        obj = self.myClass(**kwargs)
        model.DBSession.update(obj)
        submit_action = url("/%s/update/%s" % (self.url_prefix, obj.id))
        return dict(form=self.form, values=obj, action=submit_action,
            page_title=self.page_title)
        
    @expose(template="mirrormanager.templates.boringdeleteform")
    def delete(self, obj, **kwargs):
        obj = model.DBSession.query(self.myClass).filter_by(id = obj).one()
        confirmed = kwargs.get('confirmed', None)
        confirm_delete_form = ConfirmDeleteForm(submit_text="Yes, really delete it!")
        if confirmed:
            flash("%s has been deleted." % obj.name)
            model.DBSession.delete(obj)
            redirect(url("/adminview"))
        else:
            form = confirm_delete_form
            page_title = "Item Deletion"
            submit_action = url("/%s/delete/%s?confirmed=1" % (
                    self.url_prefix, obj.id))
            return dict(form=form, values=obj, action=submit_action, page_title=page_title)
