# -*- coding: utf-8 -*-
"""Version Controller"""

import transaction

from tg import expose, flash, require, url, request, redirect, validate
from tg.decorators import override_template
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from tgext.admin.tgadminconfig import TGAdminConfig
from tgext.admin.controller import AdminController
from repoze.what import predicates
from sqlalchemy import and_

from mirrormanager.lib.base import BaseController
from mirrormanager.model import DBSession, metadata
from mirrormanager.controllers.error import ErrorController
from mirrormanager import model
from mirrormanager.controllers.secure import SecureController

from mirrormanager import model
from mirrormanager.model import *

from mirrormanager.controllers.forms import *
from mirrormanager.controllers.utils import *
from mirrormanager.controllers.simpledbobject import *

version_form = VersionForm(submit_text='Create Version')
version_form_update = VersionForm(submit_text='Update Version')


class VersionController(SimpleDbObjectController):
    page_title = "Version"
    myClass = Version
    url_prefix="version"
    form = version_form
    form_update = version_form_update

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=form)
    def default(self, id):
        version = model.DBSession.query(Version).filter_by(id = id).one()
        submit_action = url("/version/update/%s" % version.id)
        return dict(form=self.form_update, values=version, action=submit_action,
            page_title="Version")

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=form)
    #@error_handler(SimpleDbObjectController.new)
    def create(self, **kwargs):
        try:
            product = model.DBSession.query(Product).filter_by(id = kwargs['product']).one()
        except Exception, er:
            print "Error:", er
            flash("Error: invalid product - foul play?")
            raise redirect(url("/"))

        del kwargs['product']

        SimpleDbObjectController.create(self, product=product.id, **kwargs)

    @expose(template="mirrormanager.templates.boringform")
    @validate(form=form)
    #@error_handler()
    def update(self, obj, **kwargs):
        kwargs['display'] = bool(kwargs['display'])
        model.DBSession.query(Version).update(kwargs)
        submit_action = url("/version/%s" % obj)
        redirect(submit_action)
