# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref


from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Host(DeclarativeBase):
    __tablename__ = 'host'

    
    id = Column(Integer, primary_key=True)
    name = Column(Text, unique=False, nullable=False)
    site = Column('site_id', Integer, ForeignKey("site.id"))
    idx = UniqueConstraint('site', 'name', name='idx')
    robot_email = Column(Text, default=None)
    admin_active = Column(Boolean, default=True)
    user_active = Column(Boolean, default=True)
    country = Column(String, default=None)
    bandwidth = Column(Text, default=None)
    bandwidth_int = Column(Integer, default=100)
    comment = Column(Text, default=None)
    _config = Column(PickleType, default=None)
    lastCheckedIn = Column(DateTime, default=None)
    lastCrawled = Column(DateTime, default=None)
    private = Column(Boolean, default=False)
    internet2 = Column(Boolean, default=False)
    internet2_clients = Column(Boolean, default=False)
    asn = Column(Integer, default=None)
    asn_clients = Column(Boolean, default=True)
    #countries_allowed = MultipleJoin('HostCountryAllowed')
    #netblocks = MultipleJoin('HostNetblock', orderBy='netblock')
    #acl_ips = MultipleJoin('HostAclIp', orderBy='ip')
    #categories = MultipleJoin('HostCategory')
    #exclusive_dirs = MultipleJoin('DirectoryExclusiveHost')
