# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class RepositoryRedirect(DeclarativeBase):
    """ Uses strings to allow for effective named aliases, and for
    repos that may not exist yet """
    __tablename__ = 'repository_redirect'

    id = Column(Integer, primary_key=True)
    fromRepo = Column(Text)
    toRepo = Column(Text, default=None)
    idx = UniqueConstraint('fromRepo', 'toRepo', name='idx')
