# -*- coding: utf-8 -*-
"""Sample model module."""

from sqlalchemy import *
from sqlalchemy.orm import mapper, relation
from sqlalchemy import Table, ForeignKey, Column
from sqlalchemy.types import Integer, Unicode
#from sqlalchemy.orm import relation, backref
from datetime import datetime

from mirrormanager.model import DeclarativeBase, metadata, DBSession


class Visit(DeclarativeBase):
    __tablename__ = 'visit'

    id = Column(Integer, primary_key=True)
    visit_key = Column(String)
    created = Column(DateTime, default=datetime.now)
    expiry = Column(DateTime)

    def lookup_visit(cls, visit_key):
        try:
            return cls.by_visit_key(visit_key)
        except SQLObjectNotFound:
            return None
    lookup_visit = classmethod(lookup_visit)
